#INCLUDE "Main.h"

*************************************************************
* Procedura, kter vrt objekt pro pakovn a rozpakovn
PROCEDURE CVP_GetInterface(loObj)
*@loObj - Vlastnost do kter se zape odkaz na objekt pro pakovn
loObj=CREATEOBJECT("_bix_Archiver")


*************************************************************
* vlastn tda pro pakovn a rozpakovn
DEFINE CLASS _bix_Archiver AS Custom
   Name="_bix_Archiver"
  
   * Dekompresn metoda
   PROCEDURE Decompress(loPack)
      * loPack - Objekt pro rozpakovn
      LOCAL lcDir,lcProgram,lctmpFile,lcUnpackPath,liz,lcStartupInfo,lcProcessInfo,liRet,liWFS,lcPom
      LOCAL ARRAY laDir(1)
      
      lctmpFile=m.loPack.File_S
      lcDir=ADDBS(JUSTPATH(m.lctmpFile))+ CHR(0)
      lcUnpackPath=SYS(2023)+"\"+SYS(2015)+"\" && pracovn nzev cesty
      =MKD(m.lcUnpackPath) && vytvo pracovn cestu

      * vytvo C++ strukturu z VFP objektu
      lcStartupInfo=m.loPack.SI.CreateString()
      lcProcessInfo=m.loPack.PI.CreateString()

      lcProgram = " e "+["]+m.lctmpFile+["]+" -o"+["]+m.lcUnpackPath+["]+" -y" + CHR(0)
      =cvp_SetLastError(0)
      liRet=_PP_ProcessFailed
      lcPom=m.loPack.PU.D_File+CHR(0)
      IF cvp_CreateProcess(@m.lcPom, @m.lcProgram, 0, 0, 1,  NORMAL_PRIORITY_CLASS, 0, @m.lcDir, @m.lcStartupInfo, @m.lcProcessInfo)#0
         * vborn neselhalo to
         loPack.PI.ReadString(@m.lcProcessInfo)
         liWFS=WAIT_TIMEOUT
         DO WHILE m.liWFS= WAIT_TIMEOUT
            liWFS=cvp_WaitForSingleObject(m.loPack.PI.hProcess, 250 )
         ENDDO
         =cvp_CloseHandle(m.loPack.PI.hProcess) && uzavi handle
         liz=ADIR(m.laDir,m.lcUnpackPath+"*.*","ASRH") && nati vechny soubory

         liRet=IIF(m.liz=0,_PP_PAUNFailed,;
               IIF(cvp_MoveFile((m.lcUnpackPath+m.laDir(1,1)+CHR(0)),(m.loPack.File_D+CHR(0)))=1,_PP_ErrOK,_PP_PAUNFailed))

      ENDIF
      =RemoveDirectoryAll(m.lcUnpackPath) && zlikviduj pracovn cestu
      RETURN m.liRet
   ENDPROC

   * Kompresn metoda
   PROCEDURE Compress(loPack)
      * loPack - Objekt pro rozpakovn

      LOCAL lcDir,lcProgram,lcStartupInfo,lcProcessInfo,liRet,liExitCode,lcPom

      lcDir=ADDBS(JUSTPATH(m.loPack.File_S))+ CHR(0)
      lcProgram = " a "+["]+m.loPack.File_D+["]+" "+["]+JUSTFNAME(m.loPack.File_S)+["] + CHR(0)

      lcStartupInfo=m.loPack.SI.CreateString()
      lcProcessInfo=m.loPack.PI.CreateString()

      =cvp_SetLastError(0)
      liRet=_PP_ProcessFailed
      lcPom=m.loPack.PU.C_File+CHR(0)
      IF cvp_CreateProcess(@m.lcPom, @m.lcProgram, 0, 0, 1, NORMAL_PRIORITY_CLASS, 0, @m.lcDir, @m.lcStartupInfo, @m.lcProcessInfo)#0
         * vborn neselhalo to
         loPack.PI.ReadString(@m.lcProcessInfo)

         liExitCode=STILL_ACTIVE
         DO WHILE m.liExitCode=STILL_ACTIVE
            =cvp_Sleep(500)
            =cvp_GetExitCodeProcess(m.loPack.PI.hProcess,@m.liExitCode )
         ENDDO

         =cvp_CloseHandle(m.loPack.PI.hProcess) && uzavi handle
         liRet=_PP_ErrOK
      ENDIF
      RETURN m.liRet
   ENDPROC
ENDDEFIN